(*let pi = 3.1415926535897932384626433832795 in*)
let pi = 3.14159265358979 in
let large_d = 4.4544551033807686783083602485579e-6 in
let large_n = 9 in

let lfabs x = 
if x >= 0.0 then x
            else -.x

in

let rec ur_tan_loop i t x2 =
if i < 3 then t
         else (ur_tan_loop (i-2) (x2 /. ((float_of_int i) -. t)) x2)

in

let ur_tan x = 
let k = (int_of_float (x/.(pi/.2.0) +. (if x>=0.0 then 0.5 else -0.5))) in
let x3 = (x -. (3217.0/.2048.0) *. (float_of_int k)) +. (large_d *. (float_of_int k)) in

(*print_float x3;*)

let x2 = x3 *. x3 in
let t = 0.0 in
(*
for i=large_n/2 downto 1 do 
    let t = x2 /. ((float_of_int (2*i+1)) -. t) in
done in
*)
let t = ur_tan_loop large_n t x2 in
(k,x3/.(1.0-.t))

in

let lsin x = 
let (k,t) = (ur_tan (x/.2.0)) in
let t = 2.0 *. t /. (1.0+.t*.t) in
if (k mod 2 = 0) then t else -.t

in

let lcos x = 
lsin (pi/.2.0 -. (lfabs x))

in

let lcos1 x = 
let (k,t) = ur_tan (lfabs (x/.2.0)) in
let t = t *. t in
if (k mod 2 = 0) then 2.0*.t/.(1.0+.t)
                 else 2.0/.(1.0+.t)

in

let rec latan_loop i x a =
if i >= 1 then latan_loop (i-1) x (((float_of_int (i*i))*.x*.x)/.((float_of_int (2*i+1))+.a))
          else a

in

let latan x =
let sgn = if x > 1.0 then 1 else
          if x < -1.0 then -1 else 0 in
let x2 = if (x > 1.0 || x < -1.0) then 1.0/.x else x in
let a = 0.0 in
let a = latan_loop 24 x2 a in
if sgn > 0 then pi/.2.0-.x2/.(1.0+.a) else
if sgn < 0 then -.pi/.2.0-.x2/.(1.0+.a) else
x2/.(1.0+.a)

in

let rec linv_loop xnew abs_x i =
let a = xnew in
let xnew = (2.0-.abs_x*.a)*.a in
if i > 20 then a else (*too many loop error*)
if a < xnew then linv_loop xnew abs_x (i+1)
            else a

in

let linv x =
let abs_x = if x <= 0.0 then -.x else x in
let xnew = if abs_x < 1.0 then
              if abs_x < 0.00000000000000000000000000000000001 then 100000000000000000000000000000000000.0 else
              if abs_x < 0.000000000000000000000000000001 then 1000000000000000000000000000000.0 else
              if abs_x < 0.0000000000000000000000001 then 10000000000000000000000000.0 else
              if abs_x < 0.00000000000000000001 then 100000000000000000000.0 else
              if abs_x < 0.000000000000001 then 1000000000000000.0 else
              if abs_x < 0.0000000001 then 10000000000.0 else
              if abs_x < 0.00001 then 100000.0 else
              if abs_x < 0.1 then 10.0 else
              if abs_x < 0.2 then 5.0 else
              if abs_x < 0.5 then 2.0 else 1.0
                          else
              if abs_x < 2.0 then 0.5 else
              (*if abs_x < 5.0 then 0.2 else
              if abs_x < 10.0 then 0.1 else
              if abs_x < 20.0 then 0.05 else
              if abs_x < 50.0 then 0.02 else*)
              if abs_x < 100.0 then 0.01 else
              (*if abs_x < 200.0 then 0.005 else
              if abs_x < 500.0 then 0.002 else*)
              if abs_x < 1000.0 then 0.001 else
              (*if abs_x < 10000.0 then 0.0001 else
              if abs_x < 100000.0 then 0.00001 else*)
              if abs_x < 1000000.0 then 0.000001 else
              (*if abs_x < 10000000.0 then 0.0000001 else
              if abs_x < 100000000.0 then 0.00000001 else*)
              if abs_x < 1000000000.0 then 0.000000001 else
              (*if abs_x < 10000000000.0 then 0.0000000001 else
              if abs_x < 100000000000.0 then 0.00000000001 else*)
              if abs_x < 1000000000000.0 then 0.000000000001 else
              (*if abs_x < 10000000000000.0 then 0.0000000000001 else
              if abs_x < 100000000000000.0 then 0.00000000000001 else*)
              if abs_x < 1000000000000000.0 then 0.000000000000001 else
              (*if abs_x < 10000000000000000.0 then 0.0000000000000001 else
              if abs_x < 100000000000000000.0 then 0.00000000000000001 else*)
              if abs_x < 1000000000000000000.0 then 0.000000000000000001 else
              if abs_x < 10000000000000000000.0 then 0.0000000000000000001 else
              if abs_x < 100000000000000000000.0 then 0.00000000000000000001 else
              if abs_x < 1000000000000000000000.0 then 0.000000000000000000001 else
              if abs_x < 10000000000000000000000.0 then 0.0000000000000000000001 else
              if abs_x < 100000000000000000000000.0 then 0.00000000000000000000001 else
              if abs_x < 1000000000000000000000000.0 then 0.000000000000000000000001 else
              if abs_x < 10000000000000000000000000.0 then 0.0000000000000000000000001 else
              if abs_x < 100000000000000000000000000.0 then 0.00000000000000000000000001 else
              if abs_x < 1000000000000000000000000000.0 then 0.000000000000000000000000001 else
              if abs_x < 10000000000000000000000000000.0 then 0.0000000000000000000000000001 else
              if abs_x < 100000000000000000000000000000.0 then 0.00000000000000000000000000001 else
              if abs_x < 1000000000000000000000000000000.0 then 0.000000000000000000000000000001 else
              if abs_x < 10000000000000000000000000000000.0 then 0.0000000000000000000000000000001 else
              if abs_x < 100000000000000000000000000000000.0 then 0.00000000000000000000000000000001 else
              if abs_x < 1000000000000000000000000000000000.0 then 0.000000000000000000000000000000001 else
              if abs_x < 10000000000000000000000000000000000.0 then 0.0000000000000000000000000000000001 else
              if abs_x < 100000000000000000000000000000000000.0 then 0.00000000000000000000000000000000001 else
              if abs_x < 1000000000000000000000000000000000000.0 then 0.000000000000000000000000000000000001 else
              if abs_x < 10000000000000000000000000000000000000.0 then 0.0000000000000000000000000000000000001 else
              if abs_x < 100000000000000000000000000000000000000.0 then 0.00000000000000000000000000000000000001 else
              0.000000000000000000000000000000000000001 in
let i = 0 in
let a = linv_loop xnew abs_x i in
if x <= 0.0 then -.a else a

in


let rec lfinvsqrt_loop xnew x i =
let a = xnew in
let xnew = (3.0-.x*.a*.a)*.a/.2.0 in
if i = 25 then a else (*too many loop error*)
lfinvsqrt_loop xnew x (i+1)
(*
if a < xnew then lfinvsqrt_loop xnew x (i+1)
            else a
*)
in

let lfinvsqrt x =
let abs_x = if x <= 0.0 then -.x else x in
let xnew = if abs_x < 1.0 then
              if abs_x < 0.000000000000000000000000000000000001 then 1000000000000000000.0 else
              if abs_x < 0.00000000000000000000000000000001 then 10000000000000000.0 else
              if abs_x < 0.0000000000000000000000000001 then 100000000000000.0 else
              if abs_x < 0.000000000000000000000001 then 1000000000000.0 else
              if abs_x < 0.00000000000000000001 then 10000000000.0 else
              if abs_x < 0.0000000000000001 then 100000000.0 else
              if abs_x < 0.000000000001 then 1000000.0 else
              if abs_x < 0.00000001 then 10000.0 else
              if abs_x < 0.01 then 10.0 else
              if abs_x < 0.04 then 5.0 else
              if abs_x < 0.25 then 2.0 else 1.0
                          else
              if abs_x = 1.0 then 1.0 else
              if abs_x < 4.0 then 0.5 else
              if abs_x < 25.0 then 0.2 else
              if abs_x < 100.0 then 0.1 else
              if abs_x < 400.0 then 0.05 else
              if abs_x < 2500.0 then 0.02 else
              if abs_x < 10000.0 then 0.01 else
              if abs_x < 40000.0 then 0.005 else
              if abs_x < 250000.0 then 0.002 else
              if abs_x < 1000000.0 then 0.001 else
              if abs_x < 4000000.0 then 0.0005 else
              if abs_x < 100000000.0 then 0.0001 else
              if abs_x < 400000000.0 then 0.00005 else
              if abs_x < 10000000000.0 then 0.00001 else
              if abs_x < 40000000000.0 then 0.000005 else
              if abs_x < 1000000000000.0 then 0.000001 else
              if abs_x < 100000000000000.0 then 0.0000001 else
              if abs_x < 10000000000000000.0 then 0.00000001 else
              if abs_x < 1000000000000000000.0 then 0.000000001 else
              if abs_x < 100000000000000000000.0 then 0.0000000001 else
              if abs_x < 10000000000000000000000.0 then 0.00000000001 else
              if abs_x < 1000000000000000000000000.0 then 0.000000000001 else
              if abs_x < 100000000000000000000000000.0 then 0.0000000000001 else
              if abs_x < 10000000000000000000000000000.0 then 0.00000000000001 else
              if abs_x < 1000000000000000000000000000000.0 then 0.000000000000001 else
              if abs_x < 100000000000000000000000000000000.0 then 0.0000000000000001 else
              if abs_x < 10000000000000000000000000000000000.0 then 0.00000000000000001 else
              if abs_x < 1000000000000000000000000000000000000.0 then 0.000000000000000001 else
              0.0000000000000000001 in
let i = 0 in
if x >= 0.0 then lfabs (lfinvsqrt_loop xnew x i)
            else lfinvsqrt_loop xnew (-.x) i
in
(*library*)



(*test*)
let in_ch = open_in "input.txt" in
let out_ch = open_out "output.txt" in

(*ここからftob用関数群*)
let rec pow2 i = if i = 0 then 1 else 2 * (pow2 (i-1)) in

let rec exp_for1 i exp exp_n =
  if i = 0 then if exp_n >= 1 then exp ^ "1" else exp ^ "0"
           else if exp_n >= (pow2 i) then exp_for1 (i-1) (exp ^ "1") (exp_n - (pow2 i))
                                   else exp_for1 (i-1) (exp ^ "0") exp_n
in

let rec exp_while1 abs_flt exp_n = 
  if abs_flt >= 2.0 then exp_while1 (abs_flt/.2.0) (exp_n+1)
                    else (abs_flt,exp_for1 7 "" (exp_n+127))
in

let rec exp_for2 i exp exp_n =
  if i = 0 then if exp_n >= 1 then exp ^ "1" else exp ^ "0"
           else if exp_n >= (pow2 i) then exp_for2 (i-1) (exp ^ "1") (exp_n - (pow2 i))
                                   else exp_for2 (i-1) (exp ^ "0") exp_n
in

let rec exp_while2 abs_flt exp_n = 
  if abs_flt < 1.0 then exp_while2 (abs_flt *. 2.0) (exp_n-1)
                   else (abs_flt,exp_for2 7 "" (exp_n+127))
in

let rec pow2_m i = if i = 0 then 1.0 else (pow2_m (i+1)) /. 2.0 in

let rec mant_for i abs_flt mant = 
  if i = 22 then if abs_flt >= (pow2_m (-23)) then mant ^ "1" else mant ^ "0"
            else if abs_flt >= pow2_m (-i-1)
                 then mant_for (i+1) (abs_flt -. (pow2_m (-i-1))) (mant ^ "1")
                 else mant_for (i+1) abs_flt (mant ^ "0")
in

let ftob flt = (*floatをstringのbit列に変換*)
  let s = if flt < 0.0 then "1" else "0" in
  let abs_flt = if flt < 0.0 then ((-1.0) *. flt) else flt in
  let (abs_flt,exp) = if abs_flt >= 2.0 then exp_while1 abs_flt 0
    else if abs_flt = 0.0 then (abs_flt,"00000000")
    else if abs_flt < 1.0 then exp_while2 abs_flt 0
    else (abs_flt,"01111111")
  in
  let abs_flt = abs_flt -. 1.0 in
  let mant = mant_for 0 abs_flt "" in
  s ^ exp ^ mant
in

(*(*ftob test*)
let p = ftob 0.0 in
print_endline p;
let p = ftob 5.0 in
print_endline p;
let p = ftob 0.25 in
print_endline p;
let p = ftob 1.25 in
print_endline p;
let p = ftob (-3.0) in
print_endline p;
let p = ftob (-5.0) in
print_endline p;
*)

(*let count_n = ref 0 in*)

let test () = 
  try
    while true do
      let st_in = input_line in_ch in
      let val_in = float_of_string st_in in
      (*count_n := !count_n + 1;*)

      (*let val_out = lsin val_in in*)
      (*let val_out = lcos val_in in*)
      let val_out = latan val_in in
      (*let val_out = linv val_in in*)
      (*let val_out = lfinvsqrt val_in in*)

      (*let st_out = string_of_float val_out in*)
      let st_out = ftob val_out in

      output_string out_ch st_out;
      output_string out_ch "\n";
      (*if (!count_n mod 10000) = 0 then print_int ((!count_n)/10000) else ();*)
    done;
  with
    End_of_file -> close_in in_ch;close_out out_ch;()
in
test ();;

(*
let st_in = 
  try
    input_line in_ch
  with End_of_file ->
    "end of file" in

while st_in != "end of file" do
  let val_in = float_of_string st_in in

  let val_out = lsin val_in in

  let st_out = string_of_float val_out in
  output_string out_ch st_out;
  let st_in = 
    try
      input_line in_ch
    with End_of_file ->
      "end of file" in
done
close_in in_ch;
close_out out_ch;
()
*)

(*
lfinvsqrt 9.0;;
*)
(*
lsin (pi/.2.0);;
*)
(*
lcos (pi/.2.0);;
*)
(*
lcos1 (pi/.2.0);;
*)
(*
latan 1.0;;
*)
(*
linv 7.0;;
*)
