sub btoi32{   #32ビット列を整数に
    ($in) = @_;
    $rev = reverse($in);
    $integer = 0;
    $exp_n = 0;
    if(substr($in,0,1) eq "0"){
	for($i=0;$i<31;$i++){
	    if(substr($rev,$i,1) eq "1"){
		$integer += 2 ** $i;
	    }
	}
    }else{
	for($i=0;$i<31;$i++){
	    if(substr($rev,$i,1) eq "0"){
		$integer += 2 ** $i;
	    }
	}
	$integer += 1;
	$integer *= -1;
    }
    return $integer;
}

sub itob{     #整数をビット列に
    ($in) = @_;
    if($in >= 0){
	$bit = "0";
	for($i=30;$i>=0;$i--){
	    if($in >= (2 ** $i)){
		$in -= (2 ** $i);
		$bit .= "1";
	    }else{
		$bit .= "0";
	    }
	}
    }else{
	$bit = "1";
	$in2 = abs($in)-1;
	for($i=30;$i>=0;$i--){
	    if($in2 >= (2 ** $i)){
		$in2 -= (2 ** $i);
		$bit .= "0";
	    }else{
		$bit .= "1";
	    }
	}
    }
    
    return $bit;
}

sub btod{                #ビット列を浮動小数に
    ($in) = @_;
    $retval = 0;
    $exp = 0;
    $mant = 1;

    $exp_str = reverse(substr($in,1,8));  #exp部の計算
    for($i=0;$i<8;$i++){
	if(substr($exp_str,$i,1) eq "1"){
	    $exp += 2 ** $i;
	}
    }
    $exp -= 127;

    $mant *= 2 ** $exp;
    $mant_str = substr($in,9);            #mantissa部の計算
    for($i=0;$i<23;$i++){
	if(substr($mant_str,$i,1) eq "1"){
	    $mant += 2 ** ($exp-$i-1);
	}
    }

    $retval = $mant;
    if(substr($in,0,1) eq "1"){
	$retval *= -1;
    }
    
    if($exp_str eq "00000000"){
	return (0);
    }else{
	return ($retval);
    }
}

sub dtob{                                 #浮動小数をビット列に
    ($in) = @_ ;
    $in_abs;
    $sign;
    $exp = "";
    $exp_n = 0;
    $mant = "";
    $mant_n = 1;

    if($in < 0){
	$in_abs = (-1) * $in;
	$sign = "1";
    }else{
	$in_abs = $in;
	$sign = "0";
    }

    if($in_abs >= 2){                    #exp部の計算
	while($in_abs >= 2){
	    $exp_n += 1;
	    $in_abs /= 2;
	}
	$exp_n += 127;
	for($i=7;$i>=0;$i--){
	    if($exp_n >= (2 ** $i)){
		$exp_n -= 2 ** $i;
		$exp .= "1";
	    }else{
		$exp .= "0";
	    }
	}
    }elsif($in_abs == 0){
	$exp = "00000000";
    }elsif($in_abs < 1){
	while($in_abs < 1){
	    $exp_n -= 1;
	    $in_abs *= 2;
	}
	$exp_n += 127;
	for($i=7;$i>=0;$i--){
	    if($exp_n >= (2 ** $i)){
		$exp_n -= 2 ** $i;
		$exp .= "1";
	    }else{
		$exp .= "0";
	    }
	}
    }else{                   #1<= $in_abs < 2
	$exp = "01111111";
    }                        #exp部の計算
    
    $in_abs -= 1;            #mantissa部の計算
	for($i=0;$i<23;$i++){
	    if($in_abs >= (2 ** (-$i-1))){
		$mant .= "1";
		$in_abs -= (2 ** (-$i-1));
	    }else{
		$mant .= "0";
	    }
	}

    return ($sign . $exp . $mant);
}

sub btoi{              #仮数部23bitの列を整数に
    ($in) = @_;
    $val = 0;
    $rev = reverse($in);
    for($i=0;$i<23;$i++){
	if(substr($rev,$i,1) eq "1"){
	    $val += 2 ** $i;
	}
    }

    return ($val);
}

sub compare{                                  #bit列の比較
    ($in1,$in2,$out,$RESULT,$FUNC) = @_;      #$in1,$in2,$outはビット列
    if(substr($in1,1,8) eq "11111111" || substr($in2,1,8) eq "11111111"){ #入力がNaN or Inf
	#print "not a number\n";                               #
	return;
    }

    #if(substr($in1,1,8) eq "00000000"){  # exp部が0
#	$in1_n = 0;
#    }else{
	$in1_n = btod($in1);
#    }
#    if(substr($in2,1,8) eq "00000000"){
#	$in2_n = 0;
#    }else{
	$in2_n = btod($in2);
#    }


    if($FUNC eq "0000"){           #FADD
	$res_n = $in1_n + $in2_n;
    }elsif($FUNC eq "0001"){       #FSUB
	$res_n = $in1_n - $in2_n;
    }elsif($FUNC eq "0010"){       #FMUL
	$res_n = $in1_n * $in2_n;
    }elsif($FUNC eq "0110"){       #FLESS
	if($in1_n < $in2_n){
	    $result = "11111111111111111111111111111111";
	}else{
	    $result = "00000000000000000000000000000000";
	}
    }elsif($FUNC eq "1000"){       #ITOF
	$res_n = btoi32($in1);
    }elsif($FUNC eq "1100"){       #FTOI
	if($in1_n >= 0){
	    $res_n = int($in1_n+0.5);
	}else{
	    $res_n = int($in1_n-0.5);
	}
	#printf "%.30f\n",$res_n;
    }elsif($FUNC eq "1110"){       #INV
	if($in1_n == 0){
	    #print "input 0 to inv.\n";                                #
	    return;
	}
	$res_n = 1 / $in1_n;
    }elsif($FUNC eq "0101"){       #FINVSQRT
	if($in1_n <= 0){
	    #print "input 0 or negative to finvsqrt.\n";               #
	    return;
	}
	$res_n = 1 / sqrt($in1_n);
    }

    #$test = itob($res_n);
    #print "$test\n";

    if($FUNC != "0110" && $FUNC != "1100"){
	$result = dtob($res_n);
    }elsif($FUNC eq "1100"){                            #FTOI
	if($res_n >= 2 ** 32){ #FTOIのINT_MAX
	    $result = "01111111111111111111111111111111";
	}elsif($res_n <= -(2 ** 32)){ #FTOIのINT_MIN
	    $result = "10000000000000000000000000000000";
	}else{
	    $result = itob($res_n);
	}
    }
    #非正規化数のチェック 非正規化数はサポートしない
    if(abs($res_n) >= 2 ** 128 && $FUNC != "1100" && $FUNC != "0110"){    #オーバーフロー
	#print "overflow\n";                                           #
	return;
    }
    if(abs($res_n) < 2 ** (-126) && $FUNC != "1100" && $FUNC != "0110"){ #アンダーフロー #2 ^ (-127)??
	#print "underflow\n";                                          #
	return;
    }


    if($FUNC eq "1100"){          #FTOIでは1bitの差は許さない
	if($out != $result){
	    print $RESULT "not match  \nSRC1  :$in1 \nSRC2  :$in2 \nRESULT:$result \nOUTPUT:$out";
	    $out_n = btod($out);
	    print $RESULT "$in1_n $in2_n $res_n $out_n\n";
	}
	return;
    }

    if(substr($out,0,9) != substr($result,0,9)){                       #符号と指数部のチェック
	print $RESULT "not match in exponent \nSRC1  :$in1 \nSRC2  :$in2 \nRESULT:$result \nOUTPUT:$out";
	$out_n = btod($out);
	print $RESULT "$in1_n $in2_n $res_n $out_n\n";
    }
    if(abs(btoi(substr($out,9,23)) - btoi(substr($result,9,23))) > 1){ #仮数部をチェック
	print $RESULT "not match in mantissa \nSRC1  :$in1 \nSRC2  :$in2 \nRESULT:$result \nOUTPUT:$out";
	$out_n = btod($out);
	print $RESULT "$in1_n $in2_n $res_n $out_n\n";
    }

}

sub atan_test{
#32ビット浮動小数を越えるかチェック(>2^(128))
    ($in_line,$out_line,$RESULT) = @_;

    #if(abs($in_line) < 2 ** (-127) || abs($in_line) >= 2 ** (128)){        #floatで表せない範囲
    #if(abs($in_line) < -(2 ** (30)) || abs($in_line) > 2 ** (30)){        #円周率の誤差が入ると思われる範囲
#	return;
    #}

    $ataned = atan2($in_line,1);                  #Perlのライブラリによるsin
    $atan_str = dtob($ataned);
    #$out_str = dtob($out_line);
    $out_str = $out_line;

    if(substr($atan_str,0,9) != substr($out_str,0,9)){
    #if(substr($atan_str,0,1) != substr($out_str,0,1)){
	print $RESULT "$in_line$ataned\n$out_line$atan_str\n$out_str\n";
	return;
    }
    if(abs(btoi(substr($atan_str,9,23)) - btoi(substr($out_str,9,23))) > 1){
    #if(abs(btoi32($atan_str) - btoi32($out_str)) > 1){
	print $RESULT "$in_line$ataned\n$out_line$atan_str\n$out_str\n";
	return;
    }

    #print $RESULT "$in_line $ataned\n$out_line$atan_str\n$out_str\n";
    return;

}

sub cos_test{
    ($in_line,$out_line,$RESULT) = @_;

    #if(abs($in_line) < 2 ** (-127) || abs($in_line) >= 2 ** (128)){        #floatで表せない範囲
    if(abs($in_line) < -(2 ** (20)) || abs($in_line) > 2 ** (20)){        #円周率の誤差が入ると思われる範囲
	return;
    }

    $cosed = cos $in_line;                  #Perlのライブラリによるsin
    $cos_str = dtob($cosed);
    #$out_str = dtob($out_line);
    $out_str = $out_line;

    if($cos_str == "00111111100000000000000000000000" && $out_str == "00111111011111111111111111111111"){
	return;
    }

    if($out_str == "00111111100000000000000000000000" && $cos_str == "00111111011111111111111111111111"){
	return;
    }


    if(substr($cos_str,0,9) != substr($out_str,0,9)){
    #if(substr($cos_str,0,1) != substr($out_str,0,1)){
	print $RESULT "$in_line$cosed\n$out_line$cos_str\n$out_str\n";
	return;
    }
    if(abs(btoi(substr($cos_str,9,23)) - btoi(substr($out_str,9,23))) > 1){
    #if(abs(btoi32($cos_str) - btoi32($out_str)) > 1){
	#$w = btoi32($cos_str);$q = btoi32($out_str);print "$cos_str=$w, $out_str=$q\n";
	print $RESULT "$in_line$cosed\n$out_line$cos_str\n$out_str\n";
	return;
    }

    #print $RESULT "$in_line $cosed\n$out_line$cos_str\n$out_str\n";
    return;
}

sub sin_test{
    ($in_line,$out_line,$RESULT) = @_;

    #if(abs($in_line) < 2 ** (-127) || abs($in_line) >= 2 ** (128)){        #floatで表せない範囲
    if(abs($in_line) < -(2 ** (30)) || abs($in_line) > 2 ** (30)){        #円周率の誤差が入ると思われる範囲
	return;
    }

    $sined = sin $in_line;                  #Perlのライブラリによるsin
    $sin_str = dtob($sined);
    #$out_str = dtob($out_line);
    $out_str = $out_line;

    if(substr($sin_str,0,9) != substr($out_str,0,9)){
    #if(substr($sin_str,0,1) != substr($out_str,0,1)){
	print $RESULT "$in_line$sined\n$out_line$sin_str\n$out_str\n";
	return;
    }
    if(abs(btoi(substr($sin_str,9,23)) - btoi(substr($out_str,9,23))) > 1){
    #if(abs(btoi32($sin_str) - btoi32($out_str)) > 1){
	print $RESULT "$in_line$sined\n$out_line$sin_str\n$out_str\n";
	return;
    }

    #print $RESULT "$in_line $sined\n$out_line$sin_str\n$out_str\n";
    return;
}

sub inv_test{
    ($in_line,$out_line,$RESULT) = @_;

    #if(abs($in_line) < 2 ** (-127) || abs($in_line) >= 2 ** (128)){        #floatで表せない範囲
    #if(abs($in_line) < -(2 ** (30)) || abs($in_line) > 2 ** (30)){        #円周率の誤差が入ると思われる範囲
    if($in_line == 0){    #入力が0
	return;
    }

    $inved = 1 / $in_line;                  #Perlのライブラリによるsin
    $inv_str = dtob($inved);
    #$out_str = dtob($out_line);
    $out_str = $out_line;

    if(substr($inv_str,0,9) != substr($out_str,0,9)){
    #if(substr($inv_str,0,1) != substr($out_str,0,1)){
	print $RESULT "$in_line$inved\n$out_line$inv_str\n$out_str\n";
	return;
    }
    if(abs(btoi(substr($inv_str,9,23)) - btoi(substr($out_str,9,23))) > 1){
    #if(abs(btoi32($inv_str) - btoi32($out_str)) > 1){
	print $RESULT "$in_line$inved\n$out_line$inv_str\n$out_str\n";
	return;
    }

    #print $RESULT "$in_line $inved\n$out_line$inv_str\n$out_str\n";
    return;
}

sub finvsqrt_test{
    ($in_line,$out_line,$RESULT) = @_;

    #if(abs($in_line) < 2 ** (-127) || abs($in_line) >= 2 ** (128)){        #floatで表せない範囲
    #if(abs($in_line) < -(2 ** (30)) || abs($in_line) > 2 ** (30)){        #円周率の誤差が入ると思われる範囲
    if($in_line <= 0){    #入力が0または負
	return;
    }

    $invsqed = sqrt(1 / $in_line);                  #Perlのライブラリによるsin
    $invsq_str = dtob($invsqed);
    #$out_str = dtob($out_line);
    $out_str = $out_line;

    if(substr($invsq_str,0,9) != substr($out_str,0,9)){
    #if(substr($invsq_str,0,1) != substr($out_str,0,1)){
	print $RESULT "$in_line$invsqed\n$out_line$invsq_str\n$out_str\n";
	return;
    }
    if(abs(btoi(substr($invsq_str,9,23)) - btoi(substr($out_str,9,23))) > 1){
    #if(abs(btoi32($invsq_str) - btoi32($out_str)) > 1){
	print $RESULT "$in_line$invsqed\n$out_line$invsq_str\n$out_str\n";
	return;
    }

    #print $RESULT "$in_line $invsqed\n$out_line$invsq_str\n$out_str\n";
    return;
}

sub main{
    open(IN,"< input.txt");
    open(OUT,"< output.txt");
    open($RESULT,"> result.txt");
    print $RESULT "";   #result.txt初期化
    close($RESULT);
    open($RESULT,">> result.txt");
    $count = 0;
    $count2 = 0;
    while($in_line = <IN>){
	$out_line = <OUT>;

	#$aaaaa = $in_line + 1;
	#print "$aaaaa,$out_line+2";

	#print $RESULT "$count\n";

	#cos_test($in_line,$out_line,$RESULT);
	#sin_test($in_line,$out_line,$RESULT);
	atan_test($in_line,$out_line,$RESULT);
	#inv_test($in_line,$out_line,$RESULT);
	#finvsqrt_test($in_line,$out_line,$RESULT);

	$count += 1;
	if($count % 10000 == 0){
	    print "$count2\n";
	    $count2 += 1;
	}
    }
    close(IN);
    close(OUT);
    close($RESULT);
}

main;

#$v = sin(0.0000000000000000000001);
#print "$v\n"; 
#$b = sin(-4.95234180169e-17);
#print "$b\n";

$c = atan2(1,1);
print "$c\n";
$t = dtob(247015136.0);
print "$t\n";
